<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2004-2012 The Cacti Group                                 |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti: The Complete RRDTool-based Graphing Solution                     |
 +-------------------------------------------------------------------------+
 | This code is designed, written, and maintained by the Cacti Group. See  |
 | about.php and/or the AUTHORS file for specific developer information.   |
 +-------------------------------------------------------------------------+
 | http://www.cacti.net/                                                   |
 +-------------------------------------------------------------------------+
*/

global $menu;

$messages = array(
	1  => array(
		"message" => _('Save Successful.'),
		"type" => "info"),
	2  => array(
		"message" => _('Save Failed.'),
		"type" => "error"),
	3  => array(
		"message" => _('Save Failed: Field Input Error (Check Red Fields).'),
		"type" => "error"),
	4  => array(
		"message" => _('Passwords do not match, please retype.'),
		"type" => "error"),
	5  => array(
		"message" => _('You must select at least one field.'),
		"type" => "error"),
	6  => array(
		"message" => _('You must have built in user authentication turned on to use this feature.'),
		"type" => "error"),
	7  => array(
		"message" => _('XML parse error.'),
		"type" => "error"),
	12 => array(
		"message" => _('Username already in use.'),
		"type" => "error"),
	15 => array(
		"message" => _('XML: Cacti version does not exist.'),
		"type" => "error"),
	16 => array(
		"message" => _('XML: Hash version does not exist.'),
		"type" => "error"),
	17 => array(
		"message" => _('XML: Generated with a newer version of Cacti.'),
		"type" => "error"),
	18 => array(
		"message" => _('XML: Cannot locate type code.'),
		"type" => "error"),
	19 => array(
		"message" => _('Username already exists.'),
		"type" => "error"),
	20 => array(
		"message" => _('Username change not permitted for designated template or guest user.'),
		"type" => "error"),
	21 => array(
		"message" => _('User delete not permitted for designated template or guest user.'),
		"type" => "error"),
	22 => array(
		"message" => _('User delete not permitted for designated graph export user.'),
		"type" => "error"),
	23 => array(
		"message" => _('Data Template Includes Deleted Round Robin Archive.  Please run Database Repair Script to Identify and/or Correct.'),
		"type" => "error"),
	24 => array(
		"message" => _('Graph Template Includes Deleted GPrint Prefix.  Please run Database Repair Script to Identify and/or Correct.'),
		"type" => "error"),
	25 => array(
		"message" => _('Graph Template Includes Deleted CDEFs.  Please run Database Repair Script to Identify and/or Correct.'),
		"type" => "error"),
	26 => array(
		"message" => _('Graph Template Includes Deleted Data Input Method.  Please run Database Repair Script to Identify.'),
		"type" => "error"),
	27 => array(
		"message" => _('Data Template Not Found during Export.  Please run Database Repair Script to Identify.'),
		"type" => "error"),
	28 => array(
		"message" => _('Host Template Not Found during Export.  Please run Database Repair Script to Identify.'),
		"type" => "error"),
	29 => array(
		"message" => _('Data Query Not Found during Export.  Please run Database Repair Script to Identify.'),
		"type" => "error"),
	30 => array(
		"message" => _('Graph Template Not Found during Export.  Please run Database Repair Script to Identify.'),
		"type" => "error"),
	);

$cdef_operators = array(1 =>
	"+",
	"-",
	"*",
	"/",
	"%");

$cdef_functions = array(1 =>
	"SIN",
	"COS",
	"LOG",
	"EXP",
	"FLOOR",
	"CEIL",
	"LT",
	"LE",
	"GT",
	"GE",
	"EQ",
	"IF",
	"MIN",
	"MAX",
	"LIMIT",
	"DUP",
	"EXC",
	"POP",
	"UN",
	"UNKN",
	"PREV",
	"INF",
	"NEGINF",
	"NOW",
	"TIME",
	"LTIME");

$input_types = array(
	DATA_INPUT_TYPE_SNMP => _("SNMP"), // Action 0:
	DATA_INPUT_TYPE_SNMP_QUERY => _("SNMP Query"),
	DATA_INPUT_TYPE_SCRIPT => _("Script/Command"),  // Action 1:
	DATA_INPUT_TYPE_SCRIPT_QUERY => _("Script Query"), // Action 1:
	DATA_INPUT_TYPE_PHP_SCRIPT_SERVER => _("Script - Script Server (PHP)"),
	DATA_INPUT_TYPE_QUERY_SCRIPT_SERVER => _("Script Query - Script Server")
	);

$reindex_types = array(
	DATA_QUERY_AUTOINDEX_NONE => _("None"),
	DATA_QUERY_AUTOINDEX_BACKWARDS_UPTIME => _("Uptime Goes Backwards"),
	DATA_QUERY_AUTOINDEX_INDEX_NUM_CHANGE => _("Index Count Changed"),
	DATA_QUERY_AUTOINDEX_FIELD_VERIFICATION => _("Verify All Fields")
	);

$snmp_query_field_actions = array(1 =>
	_("SNMP Field Name (Dropdown)"),
	_("SNMP Field Value (From User)"),
	_("SNMP Output Type (Dropdown)"));

$consolidation_functions = array(1 =>
	"AVERAGE",
	"MIN",
	"MAX",
	"LAST");

$data_source_types = array(1 =>
	"GAUGE",
	"COUNTER",
	"DERIVE",
	"ABSOLUTE");

$graph_item_types = array(
	GRAPH_ITEM_TYPE_COMMENT => "COMMENT",
	GRAPH_ITEM_TYPE_HRULE   => "HRULE",
	GRAPH_ITEM_TYPE_VRULE   => "VRULE",
	GRAPH_ITEM_TYPE_LINE1   => "LINE1",
	GRAPH_ITEM_TYPE_LINE2   => "LINE2",
	GRAPH_ITEM_TYPE_LINE3   => "LINE3",
	GRAPH_ITEM_TYPE_AREA    => "AREA",
	GRAPH_ITEM_TYPE_STACK   => "STACK",
	GRAPH_ITEM_TYPE_GPRINT  => "GPRINT",
	GRAPH_ITEM_TYPE_LEGEND  => "LEGEND"
	);

$image_types = array(1 =>
	"PNG",
	"GIF",
	"SVG");

$snmp_versions = array(0 =>
	_("Not In Use"),
	_("Version 1"),
	_("Version 2"),
	_("Version 3"));

$snmp_auth_protocols = array(
	"MD5" => _("MD5 (default)"),
	"SHA" => _("SHA"));

$snmp_priv_protocols = array(
	"[None]" => _("[None]"),
	"DES" => _("DES (default)"),
	"AES128" => _("AES"));

$banned_snmp_strings = array(
	_("End of MIB"),
	_("No Such"));

$logfile_options = array(1 =>
	_("Logfile Only"),
	_("Logfile and Syslog/Eventlog"),
	_("Syslog/Eventlog Only"));

$availability_options = array(
	AVAIL_NONE => _("None"),
	AVAIL_SNMP_AND_PING => _("Ping and SNMP Uptime"),
	AVAIL_SNMP_OR_PING => _("Ping or SNMP Uptime"),
	AVAIL_SNMP => _("SNMP Uptime"),
	AVAIL_SNMP_GET_SYSDESC => _("SNMP Desc"),
	AVAIL_SNMP_GET_NEXT => _("SNMP getNext"),
	AVAIL_PING => _("Ping"));

$ping_methods = array(
	PING_ICMP => _("ICMP Ping"),
	PING_TCP => _("TCP Ping"),
	PING_UDP => _("UDP Ping"));

$logfile_verbosity = array(
	POLLER_VERBOSITY_NONE => _("NONE - Syslog Only if Selected"),
	POLLER_VERBOSITY_LOW => _("LOW - Statistics and Errors"),
	POLLER_VERBOSITY_MEDIUM => _("MEDIUM - Statistics, Errors and Results"),
	POLLER_VERBOSITY_HIGH => _("HIGH - Statistics, Errors, Results and Major I/O Events"),
	POLLER_VERBOSITY_DEBUG => _("DEBUG - Statistics, Errors, Results, I/O and Program Flow"),
	POLLER_VERBOSITY_DEVDBG => _("DEVEL - Developer DEBUG Level"));

$poller_options = array(1 =>
	"cmd.php",
	"spine");

$poller_intervals = array(
	10 => sprintf(_('Every %d Seconds'), '10'),
	15 => sprintf(_('Every %d Seconds'), '15'),
	20 => sprintf(_('Every %d Seconds'), '20'),
	30 => sprintf(_('Every %d Seconds'), '30'),
	60 => _("Every Minute"),
	300 => _("Every 5 Minutes"));

$cron_intervals = array(
	60 => _("Every Minute"),
	300 => _("Every 5 Minutes"));

$device_threads = array(
	1 => _("1 Thread (default)"),
	2 => sprintf(_('%d Threads'), 2),
	3 => sprintf(_('%d Threads'), 3),
	4 => sprintf(_('%d Threads'), 4),
	5 => sprintf(_('%d Threads'), 5),
	6 => sprintf(_('%d Threads'), 6)
	);

$registered_cacti_names = array(
	"path_cacti");

$graph_views = array(1 =>
	_("Tree View"),
	_("List View"),
	_("Preview View"));

$graph_tree_views = array(1 =>
	_("Single Pane"),
	_("Dual Pane"));

$auth_methods = array(
	0 => _("None"),
	1 => _("Builtin Authentication"),
	2 => _("Web Basic Authentication"));
if (function_exists("ldap_connect")) {
	$auth_methods[3] = _("LDAP Authentication");
}

$auth_realms = array(0 =>
	_("Local"),
	_("LDAP"),
	_("Web Basic"));

$ldap_versions = array(
	2 => sprintf(_('Version %s'), '2'),
	3 => sprintf(_('Version %s'), '3')
	);

$ldap_encryption = array(
	0 => _("None"),
	1 => _("SSL"),
	2 => _("TLS"));

$ldap_modes = array(
	0 => _("No Searching"),
	1 => _("Anonymous Searching"),
	2 => _("Specific Searching"));

$snmp_implimentations = array(
	"ucd-snmp" => _("UCD-SNMP 4.x"),
	"net-snmp" => _("NET-SNMP 5.x"));

$rrdtool_versions = array(
	"rrd-1.0.x" => sprintf(_('RRDTool %s'), "1.0.x"),
	"rrd-1.2.x" => sprintf(_('RRDTool %s'), "1.2.x"),
	"rrd-1.3.x" => sprintf(_('RRDTool %s'), "1.3.x"),
	"rrd-1.4.x" => sprintf(_('RRDTool %s'), "1.4.x"));

$cdef_item_types = array(
	1 => _("Function"),
	2 => _("Operator"),
	4 => _("Special Data Source"),
	5 => _("Another CDEF"),
	6 => _("Custom String"));

$graph_color_alpha = array(
		"00" => "  0%",
		"19" => " 10%",
		"33" => " 20%",
		"4C" => " 30%",
		"66" => " 40%",
		"7F" => " 50%",
		"99" => " 60%",
		"B2" => " 70%",
		"CC" => " 80%",
		"E5" => " 90%",
		"FF" => "100%"
		);

$tree_sort_types = array(
	TREE_ORDERING_NONE => _("Manual Ordering (No Sorting)"),
	TREE_ORDERING_ALPHABETIC => _("Alphabetic Ordering"),
	TREE_ORDERING_NATURAL => _("Natural Ordering"),
	TREE_ORDERING_NUMERIC => _("Numeric Ordering")
	);

$tree_item_types = array(
	TREE_ITEM_TYPE_HEADER => _("Header"),
	TREE_ITEM_TYPE_GRAPH => _("Graph"),
	TREE_ITEM_TYPE_HOST => _("Host")
	);

$host_group_types = array(
	HOST_GROUPING_GRAPH_TEMPLATE => _("Graph Template"),
	HOST_GROUPING_DATA_QUERY_INDEX => _("Data Query Index")
	);

$custom_data_source_types = array(
	"CURRENT_DATA_SOURCE" => _("Current Graph Item Data Source"),
	"ALL_DATA_SOURCES_NODUPS" => _("All Data Sources (Don't Include Duplicates)"),
	"ALL_DATA_SOURCES_DUPS"	=> _("All Data Sources (Include Duplicates)"),
	"SIMILAR_DATA_SOURCES_NODUPS" => _("All Similar Data Sources (Don't Include Duplicates)"),
	"SIMILAR_DATA_SOURCES_DUPS" => _("All Similar Data Sources (Include Duplicates)"),
	"CURRENT_DS_MINIMUM_VALUE" => _("Current Data Source Item: Minimum Value"),
	"CURRENT_DS_MAXIMUM_VALUE" => _("Current Data Source Item: Maximum Value"),
	"CURRENT_GRAPH_MINIMUM_VALUE" => _("Graph: Lower Limit"),
	"CURRENT_GRAPH_MAXIMUM_VALUE" => _("Graph: Upper Limit"),
	"COUNT_ALL_DS_NODUPS" => _("Count of All Data Sources (Don't Include Duplicates)"),
	"COUNT_ALL_DS_DUPS" => _("Count of All Data Sources (Include Duplicates)"),
	"COUNT_SIMILAR_DS_NODUPS" => _("Count of All Similar Data Sources (Don't Include Duplicates)"),
	"COUNT_SIMILAR_DS_DUPS"	=> _("Count of All Similar Data Sources (Include Duplicates)"));

$menu = array(
	"Create" => array(
		"graphs_new.php" => _("New Graphs")
		),
	_("Management") => array(
		"graphs.php" => array(
			"graphs.php" => _("Graph Management"),
			"cdef.php" => _("CDEFs"),
			"color.php" => _("Colors"),
			"gprint_presets.php" => _("GPRINT Presets")
			),
		"tree.php" => _("Graph Trees"),
		"data_sources.php" => array(
			"data_sources.php" => _("Data Sources"),
			"rra.php" => _("RRAs")
			),
		"host.php" => _('Devices')
		),
	_("Collection Methods") => array(
		"data_queries.php" => _("Data Queries"),
		"data_input.php" => _("Data Input Methods")
		),
	_("Templates") => array(
		"graph_templates.php" => _("Graph Templates"),
		"host_templates.php" => _("Host Templates"),
		"data_templates.php" => _("Data Templates")
		),
	_("Import/Export") => array(
		"templates_import.php" => _("Import Templates"),
		"templates_export.php" => _("Export Templates")
		),
	_("Configuration")  => array(
		"settings.php" => _("Settings")
		),
	_("Utilities") => array(
		"utilities.php" => _("System Utilities"),
		"user_admin.php" => _("User Management"),
		"logout.php" => _("Logout User")
	));

$log_tail_lines = array(
	-1 => sprintf(_('%d Lines'), 'All'),
	10 => sprintf(_('%d Lines'), '10'),
	15 => sprintf(_('%d Lines'), '15'),
	20 => sprintf(_('%d Lines'), '20'),
	50 => sprintf(_('%d Lines'), '50'),
	100 => sprintf(_('%d Lines'), '100'),
	200 => sprintf(_('%d Lines'), '200'),
	500 => sprintf(_('%d Lines'), '500'),
	1000 => sprintf(_('%d Lines'), '1000'),
	2000 => sprintf(_('%d Lines'), '2000'),
	3000 => sprintf(_('%d Lines'), '3000'),
	5000 => sprintf(_('%d Lines'), '5000'),
	10000 => sprintf(_('%d Lines'), '10000')
	);

$item_rows = array(
	10 => "10",
	15 => "15",
	20 => "20",
	25 => "25",
	30 => "30",
	40 => "40",
	50 => "50",
	100 => "100",
	250 => "250",
	500 => "500",
	1000 => "1000",
	2000 => "2000",
	5000 => "5000"
	);

$graphs_per_page = array(
	4 => "4",
	6 => "6",
	8 => "8",
	10 => "10",
	14 => "14",
	20 => "20",
	24 => "24",
	30 => "30",
	40 => "40",
	50 => "50",
	100 => "100"
	);

$page_refresh_interval = array(
	5 => sprintf(_('%d Seconds'), '5'),
	10 => sprintf(_('%d Seconds'), '10'),
	20 => sprintf(_('%d Seconds'), '20'),
	30 => sprintf(_('%d Seconds'), '30'),
	60 => _("1 Minute"),
	300 => sprintf(_('%d Minutes'), '5'),
	600 => sprintf(_('%d Minutes'), '10'),
	9999999 => _("Never"));

$user_auth_realms = array(
	1 => _("User Administration"),
	2 => _("Data Input"),
	3 => _("Update Data Sources"),
	4 => _("Update Graph Trees"),
	5 => _("Update Graphs"),
	7 => _("View Graphs"),
	8 => _("Console Access"),
	9 => _("Update Round Robin Archives"),
	10 => _("Update Graph Templates"),
	11 => _("Update Data Templates"),
	12 => _("Update Host Templates"),
	13 => _("Data Queries"),
	14 => _("Update CDEF's"),
	15 => _("Global Settings"),
	16 => _("Export Data"),
	17 => _("Import Data")
	);

$user_auth_realm_filenames = array(
	"about.php" => 8,
	"cdef.php" => 14,
	"color.php" => 5,
	"data_input.php" => 2,
	"data_sources.php" => 3,
	"data_templates.php" => 11,
	"gprint_presets.php" => 5,
	"graph.php" => 7,
	"graph_image.php" => 7,
	"graph_xport.php" => 7,
	"graph_settings.php" => 7,
	"graph_templates.php" => 10,
	"graph_templates_inputs.php" => 10,
	"graph_templates_items.php" => 10,
	"graph_view.php" => 7,
	"graphs.php" => 5,
	"graphs_items.php" => 5,
	"graphs_new.php" => 5,
	"host.php" => 3,
	"host_templates.php" => 12,
	"index.php" => 8,
	"rra.php" => 9,
	"settings.php" => 15,
	"data_queries.php" => 13,
	"templates_export.php" => 16,
	"templates_import.php" => 17,
	"tree.php" => 4,
	"user_admin.php" => 1,
	"utilities.php" => 15,
	"smtp_servers.php" => 8,
	"email_templates.php" => 8,
	"event_queue.php" => 8,
	"smtp_queue.php" => 8,
	"logout.php" => -1
	);

$hash_type_codes = array(
	"round_robin_archive" => "15",
	"cdef" => "05",
	"cdef_item" => "14",
	"gprint_preset" => "06",
	"data_input_method" => "03",
	"data_input_field" => "07",
	"data_template" => "01",
	"data_template_item" => "08",
	"graph_template" => "00",
	"graph_template_item" => "10",
	"graph_template_input" => "09",
	"data_query" => "04",
	"data_query_graph" => "11",
	"data_query_sv_graph" => "12",
	"data_query_sv_data_source" => "13",
	"host_template" => "02"
	);

$hash_version_codes = array(
	"0.8.4"  => "0000",
	"0.8.5"  => "0001",
	"0.8.5a" => "0002",
	"0.8.6"  => "0003",
	"0.8.6a" => "0004",
	"0.8.6b" => "0005",
	"0.8.6c" => "0006",
	"0.8.6d" => "0007",
	"0.8.6e" => "0008",
	"0.8.6f" => "0009",
	"0.8.6g" => "0010",
	"0.8.6h" => "0011",
	"0.8.6i" => "0012",
	"0.8.6j" => "0013",
	"0.8.7"  => "0014",
	"0.8.7a" => "0015",
	"0.8.7b" => "0016",
	"0.8.7c" => "0017",
	"0.8.7d" => "0018",
	"0.8.7e" => "0019",
	"0.8.7f" => "0020",
	"0.8.7g" => "0021",
	"0.8.7h" => "0022",
	"0.8.7i" => "0023",
	"0.8.8"  => "0024",
	"0.8.8a" => "0024"
	);

$hash_type_names = array(
	"cdef" => _("CDEF"),
	"cdef_item" => _("CDEF Item"),
	"gprint_preset" => _("GPRINT Preset"),
	"data_input_method" => _("Data Input Method"),
	"data_input_field" => _("Data Input Field"),
	"data_template" => _("Data Template"),
	"data_template_item" => _("Data Template Item"),
	"graph_template" => _("Graph Template"),
	"graph_template_item" => _("Graph Template Item"),
	"graph_template_input" => _("Graph Template Input"),
	"data_query" => _("Data Query"),
	"host_template" => _("Host Template"),
	"round_robin_archive" => _("Round Robin Archive")
	);

$host_struc = array(
	"host_template_id",
	"description",
	"hostname",
	"notes",
	"snmp_community",
	"snmp_version",
	"snmp_username",
	"snmp_password",
	"snmp_auth_protocol",
	"snmp_priv_passphrase",
	"snmp_priv_protocol",
	"snmp_context",
	"snmp_port",
	"snmp_timeout",
	"max_oids",
	"device_threads",
	"availability_method",
	"ping_method",
	"ping_port",
	"ping_timeout",
	"ping_retries",
	"disabled",
	"status",
	"status_event_count",
	"status_fail_date",
	"status_rec_date",
	"status_last_error",
	"min_time",
	"max_time",
	"cur_time",
	"avg_time",
	"total_polls",
	"failed_polls",
	"availability"
	);

$graph_timespans = array(
	GT_LAST_HALF_HOUR => _("Last Half Hour"),
	GT_LAST_HOUR => _("Last Hour"),
	GT_LAST_2_HOURS => sprintf(_('Last %d Hours'), '2'),
	GT_LAST_4_HOURS => sprintf(_('Last %d Hours'), '4'),
	GT_LAST_6_HOURS => sprintf(_('Last %d Hours'), '6'),
	GT_LAST_12_HOURS => sprintf(_('Last %d Hours'), '12'),
	GT_LAST_DAY => _("Last Day"),
	GT_LAST_2_DAYS => sprintf(_('Last %d Days'), '2'),
	GT_LAST_3_DAYS => sprintf(_('Last %d Days'), '3'),
	GT_LAST_4_DAYS => sprintf(_('Last %d Days'), '4'),
	GT_LAST_WEEK => _("Last Week"),
	GT_LAST_2_WEEKS => _("Last 2 Weeks"),
	GT_LAST_MONTH => _("Last Month"),
	GT_LAST_2_MONTHS => sprintf(_('Last %d Months'), '2'),
	GT_LAST_3_MONTHS => sprintf(_('Last %d Months'), '3'),
	GT_LAST_4_MONTHS => sprintf(_('Last %d Months'), '4'),
	GT_LAST_6_MONTHS => sprintf(_('Last %d Months'), '6'),
	GT_LAST_YEAR => _("Last Year"),
	GT_LAST_2_YEARS => _("Last 2 Years"),
	GT_DAY_SHIFT => _("Day Shift"),
	GT_THIS_DAY => _("This Day"),
	GT_THIS_WEEK => _("This Week"),
	GT_THIS_MONTH => _("This Month"),
	GT_THIS_YEAR => _("This Year"),
	GT_PREV_DAY => _("Previous Day"),
	GT_PREV_WEEK => _("Previous Week"),
	GT_PREV_MONTH => _("Previous Month"),
	GT_PREV_YEAR => _("Previous Year")
	);

$graph_timeshifts = array(
	GTS_HALF_HOUR => _("30 Min"),
	GTS_1_HOUR => _("1 Hour"),
	GTS_2_HOURS => sprintf(_('%d Hours'), '2'),
	GTS_4_HOURS => sprintf(_('%d Hours'), '4'),
	GTS_6_HOURS => sprintf(_('%d Hours'), '6'),
	GTS_12_HOURS => sprintf(_('%d Hours'), '12'),
	GTS_1_DAY => _("1 Day"),
	GTS_2_DAYS => sprintf(_('%d Days'), '2'),
	GTS_3_DAYS => sprintf(_('%d Days'), '3'),
	GTS_4_DAYS => sprintf(_('%d Days'), '4'),
	GTS_1_WEEK => _("1 Week"),
	GTS_2_WEEKS => _("2 Weeks"),
	GTS_1_MONTH => _("1 Month"),
	GTS_2_MONTHS => sprintf(_('%d Months'), '2'),
	GTS_3_MONTHS => sprintf(_('%d Months'), '3'),
	GTS_4_MONTHS => sprintf(_('%d Months'), '4'),
	GTS_6_MONTHS => sprintf(_('%d Months'), '6'),
	GTS_1_YEAR => _("1 Year"),
	GTS_2_YEARS => _("2 Years")
	);

$graph_weekdays = array(
	WD_SUNDAY => date("l", strtotime("Sunday")),
	WD_MONDAY => date("l", strtotime("Monday")),
	WD_TUESDAY => date("l", strtotime("Tuesday")),
	WD_WEDNESDAY => date("l", strtotime("Wednesday")),
	WD_THURSDAY => date("l", strtotime("Thursday")),
	WD_FRIDAY => date("l", strtotime("Friday")),
	WD_SATURDAY => date("l", strtotime("Saturday"))
	);

$graph_dateformats = array(
	GD_MO_D_Y => _("Month Number, Day, Year"),
	GD_MN_D_Y => _("Month Name, Day, Year"),
	GD_D_MO_Y => _("Day, Month Number, Year"),
	GD_D_MN_Y => _("Day, Month Name, Year"),
	GD_Y_MO_D => _("Year, Month Number, Day"),
	GD_Y_MN_D => _("Year, Month Name, Day")
	);

$graph_datechar = array(
	GDC_HYPHEN => "-",
	GDC_SLASH => "/"
	);

$plugin_architecture = array(
	'version' => '3.1'
	);

api_plugin_hook('config_arrays');

?>
